#include "defextern.h"

#ifndef STRICT
    #define STRICT
#endif
#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <fstream.h>
#include <windows.h>
#include <commdlg.h>
#include "resource.h"
#include "file.h"

//hFile
OPENFILENAME ofn;




//-----------------------------------------------------------------------
//	

void PopFileInitialize (HWND hwnd)
{
     static TCHAR szFilter[] = TEXT (" (*.tfa)\0*.tfa\0") \
                               TEXT ("All Files (*.*)\0*.*\0\0") ;
     
     ofn.lStructSize       = sizeof (OPENFILENAME) ;
     ofn.hwndOwner         = hwnd ;
     ofn.hInstance         = NULL ;
     ofn.lpstrFilter       = szFilter ;
     ofn.lpstrCustomFilter = NULL ;
     ofn.nMaxCustFilter    = 0 ;
     ofn.nFilterIndex      = 0 ;
     ofn.lpstrFile         = NULL ;          // Set in Open and Close functions
     ofn.nMaxFile          = MAX_PATH ;
     ofn.lpstrFileTitle    = NULL ;          // Set in Open and Close functions
     ofn.nMaxFileTitle     = MAX_PATH ;
     ofn.lpstrInitialDir   = NULL ;
     ofn.lpstrTitle        = NULL ;
     ofn.Flags             = 0 ;             // Set in Open and Close functions
     ofn.nFileOffset       = 0 ;
     ofn.nFileExtension    = 0 ;
     ofn.lpstrDefExt       = TEXT ("tfa") ;
     ofn.lCustData         = 0L ;
     ofn.lpfnHook          = NULL ;
     ofn.lpTemplateName    = NULL ;
}

void setOpenFileExtTs1()
{
     static TCHAR szFilterTs1[] = TEXT ("ts1 Files (*.ts1)\0*.ts1\0") \
                               TEXT ("All Files (*.*)\0*.*\0\0") ;
     ofn.lpstrFilter       = szFilterTs1 ;
     strcpy("ts1",ofn.lpstrDefExt );
}

//-----------------------------------------------------------------------
//	

BOOL PopFileOpenDlg (HWND hwnd, PTSTR pstrFileName, PTSTR pstrTitleName)
{
     ofn.hwndOwner         = hwnd ;
     ofn.lpstrFile         = pstrFileName ;
     ofn.lpstrFileTitle    = pstrTitleName ;
     ofn.Flags             = OFN_HIDEREADONLY | OFN_CREATEPROMPT ;
     
     return GetOpenFileName (&ofn) ;
}

//...................................
//	gqŐVt@C


void makenewfilename(char *filename,char *newfile,char *new_ad)
{
	char ext[6]="";
	char *pB;
	 wsprintf(newfile,"%s",filename);
	 pB=strrchr(newfile,'.');
	 if(pB!=NULL)
	 {
		 wsprintf(ext,"%s",pB+1);
		 wsprintf(pB,"%s.%s",new_ad,ext);
	 }
	 else wsprintf(newfile,"%s%s.%s",filename,new_ad,ext);
}

//...................................
//	gqŐVt@CAAԗp,max999


void makenewfilename(char *filename,char *newfile,DWORD num)
{
	char ext[6]="";
	char *pB;
	 wsprintf(newfile,"%s",filename);
	 pB=strrchr(newfile,'.');
	 if(pB!=NULL)
	 {
		 wsprintf(ext,"%s",pB+1);
		 wsprintf(pB,"_%03d.%s",num,ext);
	 }
	 else wsprintf(newfile,"%s_%03d.%s",newfile,num,ext);
}

//...................................
//	t@CA`FbN

BOOL checkfilename(char *filename,char *nextfile)
{
	char buff[MAX_PATH];
	ifstream in;
	char ext[6]="";
	ULONG num=0;
	char *pB;
	wsprintf(buff,filename);
	 pB=strrchr(buff,'_');
	 if(pB!=NULL) *pB='\0';
	 pB=strrchr(filename,'_');
	 if(pB!=NULL) 
	 {
		 pB++;
		 wsprintf(nextfile,pB);
		 pB=strrchr(nextfile,'.');
		 wsprintf(ext,pB+1);
		 *pB='\0';
		 sscanf(nextfile,"%d",&num);
		 wsprintf(nextfile,"%s_%03d.%s",buff,num+1,ext);
		 in.open(nextfile,ios::binary | ios::nocreate);
		 if(!in)
		 {
			 num=0;
			 wsprintf(nextfile,filename);
		 }

	 }
	 else 
	 {
		 pB=strrchr(filename,'\\');
		 if(pB!=NULL) pB++;
		 else pB=filename;
		 sscanf(pB,"%s",nextfile);
	 }

	 if(num>0) return TRUE;
	 else return FALSE;
}


//...................................
//	tH_ɐVt@C


void makenewfilename(char *filename,char *newfile,char *new_ad,char *ext)
{
	char *pB;
	 wsprintf(newfile,"%s",filename);
	 pB=strrchr(newfile,'.');
	 if(pB!=NULL)
	 {
		 wsprintf(pB,"%s.%s",new_ad,ext);
	 }
	 else wsprintf(newfile,"%s%s.%s",filename,new_ad,ext);
}

//NfBNg

void getini_ex(char*initial)
{
	char cdf[MAX_PATH],cddr[MAX_PATH],cddi[MAX_PATH];
	GetModuleFileName(NULL,cdf,MAX_PATH);
	_splitpath(cdf,cddr,cddi,NULL,NULL);
	wsprintf(initial,"%s\\%s",cddr,cddi);
}

//fBNg

void getpath(char*file,char *path)
{
	char cddr[MAX_PATH],cddi[MAX_PATH];
	_splitpath(file,cddr,cddi,NULL,NULL);
	wsprintf(path,"%s%s",cddr,cddi);
}

	
//JgfBNg

void getini_cu(char*initial,char*initialfile)
{
	char cd[MAX_PATH];
	GetCurrentDirectory(MAX_PATH,cd);
	wsprintf(initial,"%s\\%s",cd,initialfile);
}

void fullname(char *file, char *buffer)
{
	if(strchr(file,'\\')==NULL) 
	{
		GetCurrentDirectory(1000,buffer);
		strcat(buffer,"\\");
		strcat(buffer,file);
	}
	else 
	{
		strcpy(buffer,file);
	}
}


DWORD getfilesize(char *name)
{
	//check length
	DWORD size=0;
	HANDLE f;
	f=CreateFile(name,GENERIC_READ,FILE_SHARE_READ,NULL,
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if(f!=NULL) 
	{
		size=max(GetFileSize(f,NULL),0);
		CloseHandle(f);
	}
	return size;
}


// gq@啶Ŕr

BOOL checkExt(char *name0,char *ext0)
{
	if (strlen(ext0)>9) return FALSE;
	BOOL f=FALSE;
	char *p;
	char name[MAX_PATH];
	char ext[10];
	strcpy(name,name0);
	strcpy(ext,ext0);
	int len=strlen(name);
	if(name[len-1]=='\"') name[len-1]=0;//NH[e[V𖳎
	p=strrchr(name,'.');
	int i;
	if(p!=NULL) if(strlen(p)<10)
	{
		p++;
		if(p!=NULL)
		{
			for(i=0;i<strlen(p);i++) 
			{
				p[i]=tolower(p[i]);
			}
			for(i=0;i<strlen(ext);i++) 
			{
				ext[i]=tolower(ext[i]);
			}
			if(strcmp(p,ext)==0) f=TRUE;
		}
	}
	return f;
}



// "" >> 
// 
void checkquote(char *file)
{
	char buf[1000];
	char *p;
	if(file[0]=='\"')
	{
		strcpy(buf,&(file[1]));
		p=strchr(buf,'\"');
		if(p!=NULL) p[0]=0;
		strcpy(file,buf);
	}
}


// t@C݂邩

BOOL exist(char *file)
{
	ifstream in(file ,ios::nocreate);
	if(!in) return FALSE;
	return TRUE;
}

BOOL IsFile(char *file)
{
	return exist(file);
}