
#include "defextern.h"

#ifndef STRICT
    #define STRICT
#endif
#include <windows.h>
#include <iostream.h>
#include <fstream.h>
#include <wininet.h>
#include <windowsx.h>
#include <commctrl.h>
/*
#include "password.h"
*/
#include "resource.h"
#include "bmedit.h"
#include "initial.h"
#include "listview.h"
#include "main.h"




int sz[]={250,50,100,320,70,20,100};//list box 

int mystricmp(char *ch1,char *ch2)
{
	int ans;
	int i=0;
	int last=min(strlen(ch1),strlen(ch2));
	while(i<=last)
	{
		ans=ch1[i]-ch2[i];
		if(ans!=0) break;
		i++;
	}
	return ans;

}


int CALLBACK MyCompProc(LPARAM lp1, LPARAM lp2, LPARAM lp3)
{
    static LVFINDINFO lvf;
    static int nItem1, nItem2;
    static char buf1[MAX_PATH], buf2[MAX_PATH];
    SORTDATA *lpsd;

    lpsd = (SORTDATA *)lp3;

    lvf.flags = LVFI_PARAM;
    lvf.lParam = lp1;
    nItem1 = ListView_FindItem(lpsd->hwndList, -1, &lvf);

    lvf.lParam = lp2;
    nItem2 = ListView_FindItem(lpsd->hwndList, -1, &lvf);
    
    ListView_GetItemText(lpsd->hwndList,
        nItem1, lpsd->isortSubItem, buf1, sizeof(buf1));

    ListView_GetItemText(lpsd->hwndList,
        nItem2, lpsd->isortSubItem, buf2, sizeof(buf2));
    if ((lpsd->isortSubItem != 1 && lpsd->isortSubItem != 3 ) || ((itemmode==URL_MODE || itemmode==MAIL_MODE )&& lpsd->isortSubItem != 1)) {
        if (lpsd->iUPDOWN == UP) {
            return(mystricmp(buf1, buf2));
        } else {
            return(mystricmp(buf1, buf2) * -1);
        }
    } else {
        if (lpsd->iUPDOWN == UP) {
            if (atoi(buf1) > atoi(buf2))
                return 1;
            else if (atoi(buf1) == atoi(buf2))
                return 0;
            else
                return -1;
        } else {
            if (atoi(buf1) > atoi(buf2))
                return -1;
            else if (atoi(buf1) == atoi(buf2))
                return 0;
            else
                return 1;
        }

    }
}


void SaveColumnSize(HWND hList)
{
    LVCOLUMN lvcol;
    lvcol.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM ;
	for (int i=0;i<NO_OF_SUBITEM-1;i++)
	{
		ListView_GetColumn(hList, i, &lvcol);
		saveinitcolumnsize(i,lvcol.cx);
	}
}


void initsizeget()
{
	int i,size;

	for(i=0;i<NO_OF_SUBITEM-1;i++)
	{
		size = initcolumnsize(i);
		if(size>0) sz[i]=size;
	}
}

void InsertMyColumn(HWND hList)
{
    LVCOLUMN lc;
	initsizeget();
	//int size[7]={130,50,130,100,100,100,100};

    lc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
    lc.fmt = LVCFMT_LEFT;
    lc.cx = sz[0];
    lc.pszText = "t@C";
    lc.iSubItem = 0;
    ListView_InsertColumn(hList, 0, &lc);

    lc.fmt = LVCFMT_RIGHT;
    lc.cx = sz[1];
    lc.pszText = "TCY";
    lc.iSubItem = 1;
    ListView_InsertColumn(hList, 1, &lc);

    lc.fmt = LVCFMT_LEFT;
    lc.cx = sz[2];
    lc.pszText = "XV";
    lc.iSubItem = 2;
    ListView_InsertColumn(hList, 2, &lc);


    lc.fmt = LVCFMT_LEFT;
    lc.cx = sz[3];
    lc.pszText = "";
    lc.iSubItem = 3;
    ListView_InsertColumn(hList, 3, &lc);

    lc.fmt = LVCFMT_LEFT;
    lc.cx = sz[4];
    lc.pszText = "MS-DOS";
    lc.iSubItem = 4;
    ListView_InsertColumn(hList, 4, &lc);

    lc.fmt = LVCFMT_LEFT;
    lc.cx = sz[5];
    lc.pszText = ".";
    lc.iSubItem = 5;
    ListView_InsertColumn(hList, 5, &lc);

    lc.fmt = LVCFMT_LEFT;
    lc.cx = sz[6];
    lc.pszText = "..";
    lc.iSubItem = 6;
    ListView_InsertColumn(hList, 6, &lc);
    return;
}



