#include "defextern.h"

#ifndef STRICT
    #define STRICT
#endif
#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <fstream.h>
#include <windows.h>
#include <commctrl.h>
#include "status.h"

void setstatusbyte(char *mes)
{
	SendMessage(hStatus, SB_SETTEXT,
                        (WPARAM)0 | 0, (LPARAM)mes);
}

void setstatusnum(int num)
{
	char mes[MAX_PATH];
	wsprintf(mes,"%d",num);
	setstatus(mes);
}

void setstatusnum(int num,int all)
{
	char mes[MAX_PATH];
	wsprintf(mes,"%d/%d",num,all);
	SendMessage(hStatus, SB_SETTEXT,
                        (WPARAM)0 | 0, (LPARAM)mes);
}



void setstatusonly(char *mes)
{
	SendMessage(hStatus, SB_SETTEXT,
                        (WPARAM)2 | 0, (LPARAM)mes);
}

void setstatusonly(int pos,char *mes)
{
	SendMessage(hStatus, SB_SETTEXT,
                        (WPARAM)pos | 0, (LPARAM)mes);
}

void setstatusfullpath(char *file)
{
	char mes[MAX_PATH];
	_fullpath(mes,file,MAX_PATH);
	SendMessage(hStatus, SB_SETTEXT,
                        (WPARAM)2 | 0, (LPARAM)mes);
}


void setstatus(char *mes)
{
	if(mes==NULL) return;
	if(strlen(mes)==0) return;
	SYSTEMTIME st;
	char jikan[10];
	char form[]="%02d:%02d:%02d";

	GetLocalTime(&st);
	wsprintf(
		jikan,
		form,
	
		st.wHour,
		st.wMinute,
		st.wSecond
	);
	SendMessage(hStatus, SB_SETTEXT,
                        (WPARAM)2 | 0, (LPARAM)mes);
	//log<<jikan<<" "<<mes<<endl;//if(*log!=NULL) *
}


void initstatus()
{
	//o[̕
	sb_size[ST_SOFT] =300 ;
	sb_size[ST_STATUS] =390 ;
	sb_size[ST_FILE] =-1 ;
}
