
//        bmedit.cpp

#define _main
#include "defextern.h"


#ifndef STRICT
    #define STRICT
#endif
#include <stdio.h>
#include <fstream.h>
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include "hwnd.h"
#include "resource.h"
#include "bmedit.h"
#include "file.h"
#include "mode.h"
#include "mail.h"
#include "edit.h"
#include "initial.h"
#include "status.h"
#include "listview.h"
#include "browse.h"
//#include "host.h"



#include "main.h"
//using namespace std;

namespace
{

#define resize() SendMessage(hWnd,WM_SIZE,0,sizelp);
#define reloadlocal() SendMessage(hWnd,WM_COMMAND,IDM_R_DIRLOCAL,0)
#define loadurlfile() SendMessage(hWnd,WM_COMMAND,IDM_OPEN_URLLIST_THIS,0)
#define loadmainfile() SendMessage(hWnd,WM_COMMAND,IDM_OPEN_URLLIST,0)
#define loadmemofile() SendMessage(hWnd,WM_COMMAND,IDM_OPEN_MEMO,0)
#define loadsearchfile() SendMessage(hWnd,WM_COMMAND,IDM_OPEN_SEARCH,0)
#define loadhisfile() SendMessage(hWnd,WM_COMMAND,IDM_OPEN_HISLIST,0)
#define loadfolderhis() SendMessage(hWnd,WM_COMMAND,IDM_OPEN_HISFOLDERLIST,0)
#define loadfavorites() SendMessage(hWnd,WM_COMMAND,IDM_FAVORITES,0)
#define loadbinfile() SendMessage(hWnd,WM_COMMAND,IDM_OPEN_URLLIST_THISplus,0)
#define loadfavfilelist() SendMessage(hWnd,WM_COMMAND,IDM_OPEN_FAVFILELIST,0)
#define loadroot() SendMessage(hWnd,WM_COMMAND,IDM_OPEN_ROOT,0)


char FilterAll[]= "*.*";
char FilterAuto[]= "*.tfa";
char *filefilter;

DWORD dw;
ofstream log;


char dragfile[MAX_PATH];
char commandline[MAX_PATH*3];
BOOL commandflag;
int localitemnum;

HWND hmainwnd;

char markon[]="<>";
char markoff[]="[]";
const int MAIN_MODE=0;

//char szDir[MAX_PATH*10], Buf1[MAX_PATH*10],Buf2[MAX_PATH*10], Buf3[MAX_PATH*10], file[MAX_PATH];
char Buf[6][MAX_PATH*100], file[MAX_PATH],buffer[100000];
char *szDir=Buf[0];

int folderbase=0;
int filebase=0;
#define FOLDER_YELLOW folderbase+0
#define FOLDER_PURPLE folderbase+1
#define FOLDER_BLUE folderbase+2
#define FOLDER_RED folderbase+3
#define FOLDER_LAST folderbase+3

#define FILE_IMAGE filebase+4
#define DRIVE_IMAGE filebase+5
#define URL_IMAGE filebase+6
#define RootFolder_IMAGE filebase+7
#define isdirectory  "."
}


char modename[8][10]={"explorer","url","mail","folder","memo","search","browser","favfile"};

#define favfiletitle "Cɓt@C"
#define searchtitle ""
#define favoritestitle "IÊCɓ"
#define BMfiletitle "URLubN}[N"
#define roottitle "X^[gtH_"
#define urlhistitle "URL"
#define folderhistitle "tH_"



void MySetListItems(HWND hListL,LVITEM &li,UINT mask, int itemno,char *item2,char *item3,char *item4,char *item5);
void MySetListItems(HWND hListL,LVITEM &li,UINT mask, char *item1,char *item2,char *item3,char *item4,char *item5);

int SetInitClassList(HWND hListL, HIMAGELIST hImage,initlist &name);
int SetRootList(HWND hListL, HIMAGELIST hImage);


void IconInit(HINSTANCE hInst, HWND hList, HIMAGELIST &hImage)
{
	hImage = ImageList_Create(16, 16, ILC_COLOR4, 2, 0);
	ListView_SetImageList(hList, hImage, LVSIL_SMALL);
	ImageList_AddIcon(hImage, LoadIcon(hInst, "FOLDER_YELLOW"));
	ImageList_AddIcon(hImage, LoadIcon(hInst, "FOLDER_PURPLE"));
	ImageList_AddIcon(hImage, LoadIcon(hInst, "FOLDER_BLUE"));
	ImageList_AddIcon(hImage, LoadIcon(hInst, "FOLDER_RED"));
	ImageList_AddIcon(hImage, LoadIcon(hInst, "MYFILE"));
	ImageList_AddIcon(hImage, LoadIcon(hInst, "MYDRIVE"));
	ImageList_AddIcon(hImage, LoadIcon(hInst, "MYURL"));
	ImageList_AddIcon(hImage, LoadIcon(hInst, "BMFOLDER"));
}


int WINAPI WinMain(HINSTANCE hCurInst, HINSTANCE hPrevInst,
                   LPSTR lpsCmdLine, int nCmdShow)
{
    MSG msg;
	HACCEL hAccel;

    if (!InitApp(hCurInst))
        return FALSE;
	wsprintf(commandline,"%s",lpsCmdLine);

    if (!InitInstance(hCurInst, nCmdShow)) 
        return FALSE;
	

	hAccel = LoadAccelerators (hCurInst, "ACCEL") ;
    while (GetMessage(&msg, NULL, 0, 0)) {
		if (!TranslateAccelerator (hmainwnd, hAccel, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
    }
    return msg.wParam;
}

//EBhEENX̓o^

ATOM InitApp(HINSTANCE hInst)
{
    WNDCLASSEX wc;
    wc.cbSize = sizeof(WNDCLASSEX);
    wc.style = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc = WndProc;    //vV[W
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInst;//CX^X
    wc.hIcon = LoadIcon(hInst, "APICON");
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName = "MYMENU";    //j[
    wc.lpszClassName = (LPCSTR)szClassName;
    wc.hIconSm = LoadIcon(hInst, "APICON");
    return (RegisterClassEx(&wc));
}


//EBhE̐

BOOL InitInstance(HINSTANCE hInst, int nCmdShow)
{

    hmainwnd = CreateWindow(szClassName,
            appname, //^Cgo[ɂ̖O\܂
            WS_OVERLAPPEDWINDOW, //EBhE̎
            CW_USEDEFAULT,    //wW
            CW_USEDEFAULT,    //xW
            CW_USEDEFAULT,    //
            CW_USEDEFAULT,    //
            NULL, //eEBhẼnhAeƂNULL
            NULL, //j[nhANXj[gƂNULL
            hInst, //CX^Xnh
            NULL);
    if (!hmainwnd)
        return FALSE;
    ShowWindow(hmainwnd, nCmdShow);
    UpdateWindow(hmainwnd);
	::hInst=hInst;
    return TRUE;
}



void settitle(HWND &hWnd)
{
	//char co[MAX_INFO],mo[30];,&appver
	wsprintf(title,"%s - %s" ,&appname,&browsername);
	setstatusonly(ST_STATUS, modename[itemmode] );
	SetWindowText(hWnd, title);
}

void resettitle()
{
	settitle(hMainWnd);
}



// c:\*\*.url @url,title o

void readshortcut(char *file,char *url,char *title)
{
	title[0]=0;
	url[0]=0;
	getpath(file,buffer);
	int i=strlen(buffer);
	char *p=file+i-1;
	if(p==NULL) p=file;
	wsprintf(title,p);
	p=strchr(title,'.');
	if (p!=NULL) p[0]=0;
	ifstream in(file);
	while(1)
	{
		in.getline(buffer,10000-2);
		if(in.gcount()==0) break;
		p=strchr(buffer,'=');
		if(p==NULL) continue;
		if(strlen(p)>0) wsprintf(url,p+1);
		break;
	}
}


void FncCommandline(char* commandline,char* pathname)
{	
	int i=0;

	/*
	if(commandline[i]=='/')
	{
		i++;
		if(commandline[i]=='p'||commandline[i]=='P')
		{
			i++;
		}
	}
	*/
	while(commandline[i]==' '||commandline[i]=='\t')i++;

	for(int j=0;i<strlen(commandline);i++)
	  if(commandline[i]!='\"')//Ƃ@肻
				 {
					  pathname[j]=commandline[i];
					  j++;
				 }
}

void setsearchwintxt(char *txt)
{
	SetWindowText(hSearchEdit,txt);
}


void setedit(char *word)
{
	SetWindowText(hEdit,word);
}

void seteditbrowsername(char *name)
{
	if(strlen(name)>0) setedit(name);
	else setedit("֘AtuEU");
}

//蔲
void showbrowserlist()
{
	strcpy(buffer,getbrowserfrominit(NULL, 1));
	for(int i=2;i<9;i++)
	{
		strcat(buffer,"\r\n");
		strcat(buffer,getbrowserfrominit(NULL, i));
	}
	setedit(buffer);
}

void test()
{
}

void setpopmenu()
{
	Browser.setbaseID(IDM_OPEN_BROWSER_0);
	Browser.setmenu(hUrlMenu);
	Browser.initmenu();
	Soft.setbaseID(IDM_OPEN_SOFT_0);
	Soft.setmenu(hSoftMenu);
	Soft.initmenu();
}

void SetDirectory(char *dir)
{
	char buffer[MAX_PATH];
	SetCurrentDirectory(dir);
	GetCurrentDirectory(MAX_PATH,buffer);
	SetWindowText(hDirEdit,buffer);
}

//"͂
void offquote(char *word)
{
	char buffer[MAX_PATH];
	char *p;
	char *pe;
	if(strlen(word)<3) return;
	if(word[0]!='\"' || word[strlen(word)-1]!='\"') return;
	strcpy(buffer,word+1);
	buffer[strlen(buffer)-1]=0;
	strcpy(word,buffer);
}

//t@Ci邢̓tH_jApXoăZbg
void MySetDirectory(char *dir)
{
	char *path=buffer;
	strcpy(path,dir);
	offquote(path);
	strcpy(dir,path);
	if(IsFile(dir)) getpath(dir,path);
	SetDirectory(path);
}

void mysoft(HWND hwnd, char* lpOperation, int num, char* lpParameters, char* dir, INT cmd)
{
	if(num>0) 
	{
		ShellExecute(hwnd, lpOperation, Soft.getpath(num),lpParameters, NULL, cmd);
		setstatusonly(ST_SOFT, Soft.getpath(num));
	}
	else 
	{
		ShellExecute(hwnd, lpOperation, lpParameters, NULL, NULL, cmd);
		setstatusonly(ST_SOFT, lpOperation);
	}
}

//EBhEvV[W

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
    static int id, iIndex,num;
	//MENUITEMINFO minfo;
	static LPARAM sizelp;
    static HINSTANCE hInst;
    RECT rc;
    HDWP hDwp;
    INITCOMMONCONTROLSEX icc;
    static LPNMHDR lpnmhdr;
	static BOOL mainfile;
    static int sortsubno[NO_OF_SUBITEM] = {DOWN};
    NMLISTVIEW *pNMLV;
    SORTDATA SortData;
    static int isortsubno=3;//ǂ̃TuACeŃ\[gĂ邩
    static int nStatus_h;//Xe[^Xo[̍
    POINT pt;
    WINPOS winpos = {20, 20, 600, 450};//eEBhËʒuA傫
    static HIMAGELIST hImage;
	int insideX,listtop,listy,edittop,edity,buttonx,buttony;

	static UINT gcf;

    switch (msg) {
        case WM_CREATE:
			PopFileInitialize (hWnd);
			editmode();
			mainfile=FALSE;
			itemmode=EXPLORER_MODE;
			filefilter=FilterAll;
			ascii=TRUE;
			hMainWnd=hWnd;
			menusetting(hWnd);
			MyGetInitialData(&winpos);
			settitle(hWnd);
            MoveWindow(hWnd, winpos.x, winpos.y, winpos.wx, winpos.wy, TRUE);
            icc.dwSize = sizeof(INITCOMMONCONTROLSEX);
            icc.dwICC = ICC_LISTVIEW_CLASSES | ICC_BAR_CLASSES;
            InitCommonControlsEx(&icc);
            hInst = ((LPCREATESTRUCT)lp)->hInstance;
            GetClientRect(hWnd, &rc);
            hListL = MakeMyList(hWnd);
            InsertMyColumn(hListL);
			/*
			*/
			hSearch = CreateWindowEx ( 0, 
				TEXT("button"), "",
                WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
				0,0,0,0, hWnd, (HMENU) ID_SEARCH, hInst, NULL) ;
			hDirL = CreateWindowEx ( 0, 
				TEXT("button"), "",
                WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
				0,0,0,0, hWnd, (HMENU) ID_DIRL, hInst, NULL) ;
			SetWindowText(hButton,markoff);
            hSearchEdit = CreateWindowEx(0,
                "edit", "",
                WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL | WS_BORDER,
                0, 0, 0, 0,    hWnd, (HMENU)ID_STATIC, hInst, NULL);
            hDirEdit = CreateWindowEx(0,
                "edit", "",
                WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL | WS_BORDER,
                0, 0, 0, 0,    hWnd, (HMENU)ID_STATICL, hInst, NULL);
            hEdit = CreateWindowEx(0,
                "edit", "",
				WS_CHILD | WS_VISIBLE | ES_MULTILINE | ES_WANTRETURN |
                WS_VSCROLL | WS_HSCROLL | ES_AUTOVSCROLL | ES_AUTOHSCROLL,
                //WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL | WS_BORDER | ES_MULTILINE ,
                0, 0, 0, 0,    hWnd, (HMENU)ID_EDIT, hInst, NULL);
            SetMyLocalDir(hWnd, hListL, hDirEdit, hImage);
            SortData.hwndList = hListL;
            SortData.isortSubItem = isortsubno;
            SortData.iUPDOWN = sortsubno[isortsubno];
            ListView_SortItems(hListL, MyCompProc, &SortData);
			initstatus();
            hStatus = CreateStatusWindow(WS_CHILD | WS_VISIBLE, "", hWnd, ID_STATUSBAR);
            SendMessage(hStatus, SB_SETPARTS, (WPARAM)3, (LPARAM)sb_size);
            GetWindowRect(hStatus, &rc);
            nStatus_h = rc.bottom - rc.top;
			IconInit(hInst, hListL, hImage);

			DragAcceptFiles(hWnd,TRUE);
			commandflag=FALSE;
			setpopmenu();
		  if(strlen(commandline)>0)
		  {
				commandflag=TRUE;
				memset(file,0,MAX_PATH);
				FncCommandline(commandline,file);
				SendMessage(hWnd,WM_DROPFILES,0,0);
		  }
		  else
		  {
			  loadmainfile();
		  }
		  if(startbrowser) myexec(NULL, "open",startpage, NULL, NULL, SW_SHOW);
            break;
        case WM_SIZE:
			sizelp=lp;
			insideX=HIWORD(lp) - nStatus_h;//
			listtop=40;
			listy=insideX - 50;
			if(mode==W_MODE_EDIT) listy =listy/3*2;
			if(mode==W_MODE_EDITONLY) 
			{
				listy =0;
				buttonx=0;
				buttony=0;
			}
			else
			{
				buttonx=26;
				buttony=24;
			}
			if(mode==W_MODE_LIST) ;
			edittop =listtop+listy;
			edity =insideX-listy-listtop;

            hDwp = BeginDeferWindowPos(4);
            hDwp = DeferWindowPos(hDwp, hDirL, HWND_TOP, LOWORD(lp) / 2 -30, 5,
                30-4, 30, SWP_SHOWWINDOW);
            hDwp = DeferWindowPos(hDwp, hSearch, HWND_TOP, LOWORD(lp) / 2 , 5,
                30-4, 30, SWP_SHOWWINDOW);
			hDwp = DeferWindowPos(hDwp, hDirEdit, HWND_TOP, 10, 5,
                LOWORD(lp) / 2 - 15-30, 30, SWP_SHOWWINDOW);
            hDwp = DeferWindowPos(hDwp, hSearchEdit, HWND_TOP, LOWORD(lp) / 2 + 5+30, 5,
                LOWORD(lp) / 2 - 15-30, 30, SWP_SHOWWINDOW);
            hDwp = DeferWindowPos(hDwp, hListL, HWND_TOP, 10, listtop,
                LOWORD(lp)  - 25, listy, SWP_SHOWWINDOW);
            hDwp = DeferWindowPos(hDwp, hEdit, HWND_TOP, 10, edittop,
                LOWORD(lp) -20, edity, SWP_SHOWWINDOW);
            EndDeferWindowPos(hDwp);
            SendMessage(hStatus, WM_SIZE, wp, lp);
			settitle(hWnd);
            break;
		case WM_TIMER:
			myexec(NULL, "open",timerUrl, NULL, NULL, SW_SHOW);
            break;
		case WM_DROPFILES:
			if(!commandflag) DragQueryFile((HDROP)wp,0,file,MAX_PATH);
			setfile(hEdit,file);
			setstatus(file);
			GetWindowText(hDirEdit,szDir,MAX_PATH);
			checkquote(szDir);
			SetCurrentDirectory(szDir);
			wsprintf(szDir,"%s",file);
			if(checkExt(file,"url")){
				readshortcut(file,Buf[2],Buf[3]);
				addurl(Buf[2],Buf[3],"","\t");
				MessageBox(hWnd, "ǉ܂", "bookmark", MB_OK);
				loadmainfile();
			}
			else loadurlfile();
			DragFinish((HDROP)wp);
			break;
        case WM_CONTEXTMENU:
            pt.x = LOWORD(lp);
            pt.y = HIWORD(lp);
            if (wp == (WPARAM)hListL) {
				if(itemmode==URL_MODE)
					TrackPopupMenu(hUrlMenu, TPM_LEFTALIGN | TPM_TOPALIGN,
                    pt.x, pt.y, 0, hWnd, NULL);
				else if(itemmode==BROWSER_MODE)
					TrackPopupMenu(hSetBrowserMenu, TPM_LEFTALIGN | TPM_TOPALIGN,
                    pt.x, pt.y, 0, hWnd, NULL);
				else 
					TrackPopupMenu(hLocalMenu, TPM_LEFTALIGN | TPM_TOPALIGN,
                    pt.x, pt.y, 0, hWnd, NULL);
            }
            
            break;
        case WM_NOTIFY:
            lpnmhdr = (LPNMHDR)lp;
			//[J
            if (lpnmhdr->hwndFrom == hListL) {
                    iIndex = ListView_GetNextItem(hListL, -1, LVNI_SELECTED);
                    ListView_GetItemText(hListL, iIndex, 0, szDir, sizeof(Buf[0]));
                    ListView_GetItemText(hListL, iIndex, 1, Buf[1], sizeof(Buf[1]));
                    ListView_GetItemText(hListL, iIndex, 2, Buf[2], sizeof(Buf[2]));
                    ListView_GetItemText(hListL, iIndex, 3, Buf[3], sizeof(Buf[3]));
                    ListView_GetItemText(hListL, iIndex, 4, Buf[4], sizeof(Buf[4]));
                    ListView_GetItemText(hListL, iIndex, 5, Buf[5], sizeof(Buf[5]));
					//
					if(mainfile) num=atoi(Buf[1]);
					if( itemmode == BROWSER_MODE ) num=atoi(Buf[1]);
                switch (lpnmhdr->code) {
					case NM_CLICK:
						hLastList = lpnmhdr->hwndFrom;
						if(itemmode==URL_MODE && singleclick==TRUE)
						{
							if(strcmp(szDir,favoritestitle)==0) ;
							else if(isMainurl(szDir)) ;
							else if (strcmp(Buf[1], isdirectory) == 0) ;
							else{//ShellExecute
								myexec(NULL, "open",szDir, NULL, NULL, SW_SHOW);
								addhistory(szDir);
								if(mainfile) setvisittime(num,"");
							}
						}
						return (DefWindowProc(hWnd, msg, wp, lp));
					case NM_DBLCLK:
						hLastList = lpnmhdr->hwndFrom;
						if(strcmp(szDir,roottitle)==0) 
						{
							setsearchwintxt("");
							itemmode =URL_MODE;
							loadroot();
							break;
						}
						if(strcmp(szDir,favoritestitle)==0) 
						{
							loadfavorites();
							break;
						}
						if(itemmode==URL_MODE)
						{
							if(strcmp(szDir,searchtitle)==0) loadsearchfile();
							else if(strcmp(szDir,urlhistitle)==0) loadhisfile();
							else if(strcmp(szDir,folderhistitle)==0) loadfolderhis();
							else if(strcmp(szDir,favfiletitle)==0) loadfavfilelist();
							else if(strcmp(szDir,BMfiletitle)==0) loadmainfile();
							else if(isMainurl(szDir))
							{
								loadmainfile();
							}
							else if (strcmp(Buf[1], isdirectory) == 0) 
							{
								loadurlfile();
							}
							else{
								myexec(NULL, "open",szDir, NULL, NULL, SW_SHOW);
								addhistory(szDir);
								if(mainfile) setvisittime(num,"");
							}
						}
						else if(itemmode ==FOLDER_MODE || itemmode ==BROWSER_MODE)
						{
								MySetDirectory(szDir);
								addhistory(szDir);
								reloadlocal();
						}
						else if(itemmode==MAIL_MODE )
						{
							wsprintf(Buf[1],"mailto:%s",szDir);
							myexec(NULL, "open",Buf[1], NULL, NULL, SW_SHOW);
							addhistory(szDir);
						}
						else if(itemmode==SEARCH_MODE)
						{
							setsearchwintxt(szDir);
							SetDirectory(getinitdir());
							loadmainfile();
							setsearchwintxt("");
						}
						else if(itemmode==FAVFILE_MODE)
						{
							loadbinfile();
						}
                        else
						{
							if(isBookmark(szDir))
							{
								SetDirectory(getinitdir());
								loadmainfile();
								break;
							}
							if(isHistory(szDir))
							{
								loadhisfile();
								break;
							}
							if(isSearch(szDir))
							{
								loadsearchfile();
								break;
							}
							if(isMainurl(szDir))
							{
								SetDirectory(getinitdir());
								loadmainfile();
								break;
							}
							if(isMemo(szDir))
							{
								loadmemofile();
								break;
							}
							if(checkExt(szDir,"htm") || checkExt(szDir,"html")) 
							{
								loadbinfile();
								break;
							}
							else if (strcmp(Buf[1], isdirectory) != 0) {
								GetCurrentDirectory(1000,Buf[1]);
								myexec(hWnd, "open",szDir, NULL, Buf[1], SW_SHOW);
								addhistory(szDir);
								break;
							}
						   SetDirectory(szDir);
						   GetCurrentDirectory(MAX_PATH,szDir);
						   addhistory(szDir);
							reloadlocal();
						}
                        break;
                    case LVN_ITEMCHANGED://NM_CLICK:
						hLastList = lpnmhdr->hwndFrom;
						//editmode();
						setstatusonly(ST_FILE, szDir);
						if(itemmode!=EXPLORER_MODE) 
						{
							wsprintf(buffer,"%s\r\n%s\r\n%s",szDir,Buf[3],Buf[4]);
							SetWindowText(hEdit,buffer);
							break;
						}
						else
						{
							if (strcmp(Buf[1], isdirectory) != 0)
							{
								seteditflag(TRUE);
								setfile(hEdit,szDir);
							}
							else
							{
								seteditflag(FALSE);
								SetWindowText(hEdit,"");
							}
						}
						break;
                    case LVN_COLUMNCLICK:
                        pNMLV = (NMLISTVIEW *)lp;
                        isortsubno = pNMLV->iSubItem;
                        if (sortsubno[isortsubno] == UP)
                            sortsubno[isortsubno] = DOWN;
                        else
                            sortsubno[isortsubno] = UP;
                        SortData.hwndList = hListL;
                        SortData.isortSubItem = isortsubno;
                        SortData.iUPDOWN = sortsubno[isortsubno];
                        if(ListView_SortItems(hListL, MyCompProc, &SortData) != TRUE)
                            setstatusonly("\[gs");
                        break;
                    default:
                        return (DefWindowProc(hWnd, msg, wp, lp));
                }
            }
            break;
        case WM_COMMAND:
			if(LOWORD(wp)>=localdirIDBASE && LOWORD(wp)<localdirIDBASE+1000 )
			{
				GetMenuString(hLocalMenu, LOWORD(wp), Buf[1], MAX_PATH,MF_BYCOMMAND);
                SetCurrentDirectory(Buf[1]);
				reloadlocal();
				break;
			}
			// uEU؂ւ
			if(LOWORD(wp)>=IDM_BROWSER_0 && LOWORD(wp)<IDM_BROWSER_0 +browsermax )
			{
				setbrowser(LOWORD(wp)-IDM_BROWSER_0);
				seteditbrowsername(browser);
				break;
			}
			// ꎞIɃuEU؂ւURLJ
			if(LOWORD(wp)>=Browser.baseID && LOWORD(wp)<Browser.baseID +browsermax )
			{
				setbrowser(LOWORD(wp)-Browser.baseID);
				seteditbrowsername(browser);
				if(itemmode==URL_MODE) myexec(NULL, "open",szDir, NULL, NULL, SW_SHOW);
				else if(checkExt(szDir,"url"))
				{
					geturlfromshortcut(szDir,Buf[1]);
					myexec(NULL, "open",Buf[1], NULL, NULL, SW_SHOW);
				}
				browserback();
				break;
			}
			// \tgŊJ
			if(LOWORD(wp)>=Soft.baseID && LOWORD(wp)<Soft.baseID +browsermax )
			{
				mysoft(NULL, "open", LOWORD(wp)-Soft.baseID ,szDir, NULL, SW_SHOW);
				break;
			}
            switch (LOWORD(wp)) {
				case ID_SEARCH:
					switch (HIWORD (wp))
					 {
					 case BN_CLICKED:
						 SetWindowText(hSearchEdit,"");
						 break;
					 default:
						 break;
					}
					break;
				case ID_DIRL:
					switch (HIWORD (wp))
					 {
					 case BN_CLICKED:
						 GetWindowText(hDirEdit,szDir,MAX_PATH*100);
						 if(isurl(szDir))
						 {
							 myexec(NULL, "open",szDir, NULL, NULL, SW_SHOW);
							 GetWindowText(hSearchEdit,Buf[1],MAX_PATH*100);
							 addurl(szDir,Buf[1],"","\t");
							 SetWindowText(hSearchEdit,"");
						 }
						 else if(checkExt(szDir,"exe"))
						 {
							 GetWindowText(hSearchEdit,Buf[1],MAX_PATH*100);
							 addbrowser(szDir,Buf[1]);
							 SetWindowText(hSearchEdit,"");
						 }
						else 
						{
							SetDirectory(szDir);
							reloadlocal();
						}
						 break;
					 default:
						 break;
					}
					break;
				case IDM_WINMODE:
					nextwinmode();
					resize();
					break;

				case IDM_test:
					test();
					break;
				case IDM_DELURLTIME:
					resetvisittime(num);
					break;
				case IDM_DEL_ALLURLTIME:
					inittimefile();
					resize();
					break;
				case IDM_TIMER:
					if(itemmode==URL_MODE)
					{
						wsprintf(timerUrl,"%s",szDir);
						SetTimer(hWnd,1,900000,NULL);//@15
					}
					break;
				case IDM_TIMER_END:
					KillTimer(hWnd,1);
					break;
				case IDM_DELURLLOCAL:
					delurlfromlist(num);
					break;
				case IDM_SET_BROWSER:
					setbrowser(num);
					break;
				case IDM_OPEN_ALL_BROWSER:
					if(itemmode==URL_MODE) 
					{
						browsernumpush();
						for (int i=0;i<=getbrowsercount();i++)
						{
							setbrowser(i);
							seteditbrowsername(browser);
							if(MessageBox(hWnd,browser,"J܂",MB_OKCANCEL)==IDOK) 
								myexec(NULL, "open",szDir, NULL, NULL, SW_SHOW);
							else break;
						}
						setbrowser(browsernumpop());
					}
					break;
				case IDM_OPEN_FOLDERLIST_THIS:
					mainfile=FALSE;
					SetFolderList(hWnd, hListL, hImage,szDir,1);
					itemmode=FOLDER_MODE;
					resize();
					break;
				case IDM_ADD_BROWSER:
					fullname(szDir, buffer);
					Browser.add(buffer);
					break;
				case IDM_ADD_SOFT:
					fullname(szDir, buffer);
					Soft.add(buffer);
					break;
				case IDM_ADD_FAVORITE:
					fullname(szDir, buffer);
					FFile.add(buffer);
					break;
				case IDM_HELP:
					open(gethelpfile());
					break;
				case IDM_OPEN_URLLIST_THISplus:
					readurlfrombin(szDir);
					strcpy(szDir,gettmp());
					//break;
				case IDM_OPEN_URLLIST_THIS:
					mainfile=FALSE;
					SetUrlList(hWnd, hListL, hImage,szDir,1);
					itemmode=URL_MODE;
					resize();
					break;
				case IDM_OPEN_MAILLIST_THIS:
					mainfile=FALSE;
					SetMailAddressList(hWnd, hListL, hImage,szDir);
					itemmode=MAIL_MODE;
					resize();
					break;

				case IDM_OPEN_URLLIST:
					if(SetUrlList(hWnd, hListL, hImage,szDir,0)==0)
					{
						itemmode=EXPLORER_MODE;
						reloadlocal();
						break;
					}
					mainfile=TRUE;
					itemmode=URL_MODE;
					SetDirectory(getinitdir());
					resize();
					break;
				case IDM_OPEN_HISLIST:
					strcpy(szDir,gethisfile());
					SetUrlList(hWnd, hListL, hImage,szDir,1);
					mainfile=FALSE;
					itemmode=URL_MODE;
					resize();
					break;
				case IDM_OPEN_HISFOLDERLIST:
					strcpy(szDir,gethisfile());
					SetFolderList(hWnd, hListL, hImage,szDir,1);
					mainfile=FALSE;
					itemmode=FOLDER_MODE;
					resize();
					break;
				case IDM_OPEN_MEMO:
					//strcpy(szDir,getmemofile());
					SetMemoList(hWnd, hListL, hImage,szDir,1);
					mainfile=FALSE;
					itemmode=MEMO_MODE;
					resize();
					break;
				case IDM_OPEN_SEARCH:
					SetSearchList(hWnd, hListL, hImage,"",1);
					mainfile=FALSE;
					itemmode=SEARCH_MODE;
					setsearchwintxt("");
					resize();
					break;
				case IDM_OPEN_BROWSERLIST:
					SetInitClassList(hListL, hImage,Browser);
					mainfile=FALSE;
					itemmode=BROWSER_MODE;
					setsearchwintxt("");
					resize();
					break;
				case IDM_OPEN_FAVFILELIST:
					SetInitClassList(hListL, hImage, FFile);
					mainfile=FALSE;
					itemmode=FAVFILE_MODE;
					setsearchwintxt("");
					resize();
					break;
				case IDM_OPEN_SOFTLIST:
					SetInitClassList(hListL, hImage, Soft);
					mainfile=FALSE;
					itemmode=FOLDER_MODE;
					setsearchwintxt("");
					resize();
					break;
				case IDM_OPEN_ROOT:
					SetRootList(hListL, hImage);
					mainfile=FALSE;
					itemmode=URL_MODE;
					setsearchwintxt("");
					resize();
					break;
				case IDM_add_url:
					if(MyAddUrl(hWnd)==IDOK) loadmainfile();
					resize();
					break;
				case IDM_add_urlfile:
					if(urlfromfile(szDir)==TRUE) loadmainfile();
					resize();
					break;
				case IDM_change_mode_sw:
					if(ascii==TRUE) SendMessage(hWnd,WM_COMMAND,IDM_changeb_mode,0);
					else SendMessage(hWnd,WM_COMMAND,IDM_change_mode,0);
					break;
				case IDM_LOCAL_CREATE_FILE:
					MyCreatFile(hWnd, hListL, hDirEdit);
					reloadlocal();
					break;
				case IDM_NEW_FILE:
					MyCreatBlankFile();
					reloadlocal();
					break;
				case IDM_RENAME:
                        iIndex = ListView_GetNextItem(hListL, -1, LVNI_SELECTED);
                        ListView_GetItemText(hListL, iIndex, 0, szDir, sizeof(Buf[0]));
                        ListView_GetItemText(hListL, iIndex, 1, Buf[1], sizeof(Buf[1]));
                        if (strcmp(Buf[1], isdirectory) != 0) {
							localrename(hWnd, hListL, hDirEdit, &myfname);
							reloadlocal();
                            break;
                        }
						else
						{
						}
					break;
				case IDM_OPEN_CUR:
                    ShellExecute(NULL, "open","explorer",".", NULL, SW_SHOW);
					break;
				case IDM_OPEN_INI:
                    openinitdir();
					break;
				case IDM_EDIT:
                        iIndex = ListView_GetNextItem(hListL, -1, LVNI_SELECTED);
                        ListView_GetItemText(hListL, iIndex, 0, szDir, sizeof(Buf[0]));
                        ListView_GetItemText(hListL, iIndex, 1, Buf[1], sizeof(Buf[1]));
                        if (strcmp(Buf[1], isdirectory) != 0) {
                            ShellExecute(NULL, "open","notepad",szDir, NULL, SW_SHOW);
                            break;
                        }
						else
						{
							ShellExecute(NULL, "open","explorer",szDir, NULL, SW_SHOW);
						}
					break;

                case IDM_LOCALDRIVE:
                    ChangeLocalDrive(hWnd, hListL, hDirEdit, hImage);
                    reloadlocal();
                    break;
                case IDM_EDIT_INIT:
					openinit();
                    break;
                case IDM_END:
                    SendMessage(hWnd, WM_CLOSE, 0, 0);
                    break;
                case IDM_DELFILELOCAL:
                    MyDelFile(hListL);
                    reloadlocal();
                    break;
                case IDM_BROWSER_plus:
					browserplus();
					seteditbrowsername(browser);
                    break;
                case IDM_BROWSER_minus:
					browserminus();
					seteditbrowsername(browser);
                    break;
                case IDM_CHECK_BROWSER:
					seteditbrowsername(browser);
					//ShellExecute(NULL, "open",browser,"http://test", NULL, SW_SHOW);
                    break;
                case IDM_CHECK_CDIR:
                    GetCurrentDirectory(100,commandline);
					SetWindowText(hEdit,commandline);
                    break;
                case IDM_CHECK_WINBOOTDIR:
                    strcpy(commandline,getenv("winbootdir"));
					SetWindowText(hEdit,commandline);
                    break;
                case IDM_LOCAL_CREATEDIR:
                    MyCreatDir(hWnd, hListL, hDirEdit);
					reloadlocal();
                    break;
                case IDM_REMOVEDIR_LOCAL:
                    MyRemoveDir(hListL);
                    reloadlocal();
                    break;
                case IDM_R_DIRLOCAL:
					itemmode=EXPLORER_MODE;
                    SetCurrentDirectory(".");
                    SetMyLocalDir(hWnd, hListL, hDirEdit, hImage);
                    SortData.hwndList = hListL;
                    SortData.isortSubItem = isortsubno;
                    SortData.iUPDOWN = sortsubno[isortsubno];
                    ListView_SortItems(hListL, MyCompProc, &SortData);
					filefilter=FilterAll;//reset 
                    break;
                case IDM_UPDIRLOCAL:
                    SetCurrentDirectory("..");
                    reloadlocal();
                    break;
                case IDM_FAVORITES:
                    MySetDirectory(favorites);
                    reloadlocal();
                    break;
                case IDM_OVERWRITE:
					//overwrite(hEdit);
                    break;
                case IDM_WINDOW_ALL:
					editmode();
					resize();
                    break;
                case IDM_WINDOW_LIST:
					listmode();
					resize();
                    break;
                case IDM_WINDOW_EDIT:
					editonlymode();
					resize();
                    break;
            }
            break;
        case WM_CLOSE:
            GetWindowRect(hWnd, &rc);
            winpos.x = rc.left;
            winpos.y = rc.top;
            winpos.wx = rc.right - rc.left;
            winpos.wy = rc.bottom -rc.top;
			SaveColumnSize(hListL);
            MySetInitialData(&winpos);
            ImageList_Destroy(hImage);
            DestroyWindow(hSearchEdit);
            DestroyWindow(hListL);
            DestroyWindow(hDirL);
            DestroyWindow(hSearch);
            DestroyWindow(hDirEdit);
            DestroyWindow(hButton);
            DestroyWindow(hWnd);
            break;
        case WM_DESTROY:
            PostQuitMessage(0);
            break;
        default:
            return (DefWindowProc(hWnd, msg, wp, lp));
    }
    return 0;
}



void setfilenameoncopy(HWND hListFrom, HWND hStaticTo, FNAME *lpfname)
{
    int iIndex;

	strcpy(lpfname->szFName,"");
    iIndex = ListView_GetNextItem(hListFrom, -1, LVNI_SELECTED);
    ListView_GetItemText(hListFrom, iIndex, 0, lpfname->szFName, MAX_PATH);
    GetWindowText(hStaticTo, lpfname->szLocalFileName,
        sizeof(lpfname->szLocalFileName));
    strcat(lpfname->szLocalFileName, "\\");
    strcat(lpfname->szLocalFileName, lpfname->szFName);
}


void MyDelFile(HWND hList)
{
    int iIndex;
	char buffer[MAX_INFO];

	strcpy(buffer,"");
    iIndex = ListView_GetNextItem(hList, -1, LVNI_SELECTED);
    ListView_GetItemText(hList, iIndex, 0, buffer, MAX_PATH);
	DeleteFile(buffer);
}

void MyRemoveDir(HWND hList)
{
    int iIndex;
	char buffer[MAX_INFO];

	strcpy(buffer,"");
    iIndex = ListView_GetNextItem(hList, -1, LVNI_SELECTED);
    ListView_GetItemText(hList, iIndex, 0, buffer, MAX_PATH);
	if(RemoveDirectory(buffer)) setstatus("fBNg폜܂");
	else setstatus("fBNg폜o܂ł");
}


void localrename(HWND hWnd,HWND hList, HWND hStatic , FNAME *lpfname)
{
	setfilenameoncopy(hList, hStatic, lpfname);
    strcpy(lpfname->szLocalFileName, lpfname->szFName);
	if (DialogBoxParam(hInst, "MYRENAME",
		hWnd, (DLGPROC)MyGetFNameProc, (LPARAM)&myfname) == IDCANCEL)
		return;
	rename(myfname.szFName,myfname.szLocalFileName);
}

LRESULT CALLBACK MyGetFNameProc(HWND hDlg, UINT msg, WPARAM wp, LPARAM lp)
{
    static FNAME *lpfname;
    static HWND hFName, hLocalFName;

    switch (msg) {
        case WM_INITDIALOG:
            lpfname = (FNAME *)lp;
            hFName = GetDlgItem(hDlg, IDC_FNAME);
            hLocalFName = GetDlgItem(hDlg, IDC_LOCALFILE);
            Edit_SetText(hFName, lpfname->szFName);
            Edit_SetText(hLocalFName, lpfname->szLocalFileName);
            SetFocus(hFName);
            break;
        case WM_COMMAND:
            switch (LOWORD(wp)) {
                case IDOK:
                    Edit_GetText(hFName, lpfname->szFName, sizeof(lpfname->szFName));
                    Edit_GetText(hLocalFName, lpfname->szLocalFileName,
                        sizeof(lpfname->szLocalFileName));
                    EndDialog(hDlg, IDOK);
                    return TRUE;
                case IDCANCEL:
                    EndDialog(hDlg, IDCANCEL);
                    return TRUE;
            }
            return FALSE;
    }
    return FALSE;
}



//gbvڂݒ肵ăXgɒǉ
void addlistitem( HWND hList,char *name,int num,int image )
{
    LVITEM li;
	const int MAX_DAT=3000;
	char buffer[MAX_DAT];
	wsprintf(buffer,"%s",name);

    li.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
    li.pszText = buffer;
    li.iItem = num;
    li.iSubItem = 0;
    li.lParam = num;
    li.iImage = image;//
    
    ListView_InsertItem(hListL, &li);
    
    li.mask = LVIF_TEXT;

    li.iSubItem = 1;
    wsprintf(li.pszText, "0");
    ListView_SetItem(hListL, &li);
    li.iSubItem = 5;
    //strcpy(li.pszText, title);
    strcpy(li.pszText, "");
    ListView_SetItem(hListL, &li);
    li.iSubItem = 3;
    strcpy(li.pszText, "");
    ListView_SetItem(hListL, &li);
    li.iSubItem = 4;
    strcpy(li.pszText, "");
    ListView_SetItem(hListL, &li);
	li.iSubItem = 2;
	if(mode==0) strcpy(li.pszText,"");
	else strcpy(li.pszText,"");
	ListView_SetItem(hListL, &li);
}

void addsearchtolist( HWND hList,int num)
{
	addlistitem( hList,searchtitle,num,FOLDER_PURPLE );
}
void addfavoritestolist( HWND hList,int num)
{
	addlistitem( hList,favoritestitle ,num,FOLDER_BLUE );
}
void addroottolist( HWND hList,int num)
{
	addlistitem( hList,roottitle,num,RootFolder_IMAGE );
}


void addSptolist( HWND hList,char *name,int num)
{
	addlistitem( hList,name,num,FOLDER_PURPLE );
}

int fileimage(char *name)
{
	if(checkExt(name,"url")) return URL_IMAGE;
	else return FILE_IMAGE;
}


void FileTimeToMyListTime(FILETIME &localft,char *txt)
{
	SYSTEMTIME localtm;
	FileTimeToSystemTime(&localft, &localtm);
	wsprintf(txt, "%02d/%02d/%02d %02d:%02d",
				localtm.wYear, localtm.wMonth, localtm.wDay, localtm.wHour, localtm.wMinute);
}

// t@CXg ǂݍݖ{

int SetMyLocalDir(HWND hWnd, HWND hListL, HWND hDirEdit, HIMAGELIST hImage)
{
    char szfname[MAX_PATH + 5],szfnameback[MAX_PATH + 5];
    WIN32_FIND_DATA wfd;
    HANDLE hFind;
    int iItemNo = 0;
    LVITEM li;
	li.pszText = szfname;
    SYSTEMTIME localtm;
    FILETIME localft;
    char szBuf[MAX_PATH],buf[MAX_PATH];
	BOOL rootflag=FALSE;

	BOOL flag=FALSE;
	GetWindowText(hSearchEdit,szBuf,MAX_PATH);
	if(strlen(szBuf)>0) flag=TRUE;

    ListView_DeleteAllItems(hListL);
    GetCurrentDirectory(MAX_PATH, szfname);
    SetWindowText(hDirEdit, szfname);
	strcpy(szfnameback,szfname);
	if(strlen(szfname)<4) rootflag=TRUE;//[g`FbN@蔲
    
    hFind = FindFirstFile(filefilter, &wfd);
    if (hFind == INVALID_HANDLE_VALUE) {
        setstatus("G[ł");
        FindClose(hFind);
        return 0;
    } else {
        strcpy(szfname, wfd.cFileName);
		
		// filter
		if( !(flag==TRUE && strstr(szfname,szBuf)==NULL) ) 
		{
			li.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
			li.iItem = iItemNo;
			li.iSubItem = 0;
			li.lParam = iItemNo;
			if (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
				li.iImage = FOLDER_YELLOW;
			} else {
				li.iImage = fileimage(szfname);
			}
			ListView_InsertItem(hListL, &li);

			li.mask = LVIF_TEXT;
			li.iSubItem = 1;
			if (!(wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
				itoa(wfd.nFileSizeLow, li.pszText, 10);
				if (wfd.nFileSizeHigh != 0)
					setstatus("t@CTCY傫܂");
			} else {
				strcpy(li.pszText, isdirectory);
			}
			ListView_SetItem(hListL, &li);

			FileTimeToLocalFileTime(&wfd.ftLastWriteTime, &localft);
			FileTimeToMyListTime(localft , li.pszText);
			li.iSubItem = 2;
			ListView_SetItem(hListL, &li);

			wsprintf(li.pszText, "%d", wfd.dwFileAttributes);
			li.iSubItem = 3;
			ListView_SetItem(hListL, &li);

			GetShortPathName(wfd.cFileName, buf, sizeof(buf));
			strcpy(li.pszText, buf);
			li.iSubItem = 4;
			ListView_SetItem(hListL, &li);
			strcpy(li.pszText, "");
			li.iSubItem = 5;
			ListView_SetItem(hListL, &li);

			iItemNo++;
		}
    }

    while (FindNextFile(hFind, &wfd)) {
        strcpy(szfname, wfd.cFileName);
		// filter
		if(flag==TRUE && strstr(szfname,szBuf)==NULL) 
		{
			continue;
		}
        li.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
        li.iItem = iItemNo;
        li.iSubItem = 0;
        li.lParam = iItemNo;
        if (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
            li.iImage = FOLDER_YELLOW;
        } else {
            li.iImage = fileimage(szfname);
        }
        ListView_InsertItem(hListL, &li);
        
        li.mask = LVIF_TEXT;
        li.iSubItem = 1;
        if (!(wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
            itoa(wfd.nFileSizeLow, li.pszText, 10);
        } else {
            strcpy(li.pszText, isdirectory);
        }
        ListView_SetItem(hListL, &li);

        FileTimeToLocalFileTime(&wfd.ftLastWriteTime, &localft);
        FileTimeToSystemTime(&localft, &localtm);
        wsprintf(li.pszText, "%02d/%02d/%02d %02d:%02d",
            localtm.wYear, localtm.wMonth, localtm.wDay, localtm.wHour, localtm.wMinute);
        li.iSubItem = 2;
        ListView_SetItem(hListL, &li);

        wsprintf(li.pszText, "%d", wfd.dwFileAttributes);
        li.iSubItem = 3;
        ListView_SetItem(hListL, &li);
        
        GetShortPathName(wfd.cFileName, buf, sizeof(buf));
        strcpy(li.pszText, buf);
        li.iSubItem = 4;

        ListView_SetItem(hListL, &li);
        strcpy(li.pszText, "");
        li.iSubItem = 5;
        ListView_SetItem(hListL, &li);

        iItemNo++;
    }
    FindClose(hFind);

	//hCu\A蔲ia-zj
	if(rootflag)
	{
		char c='a';
		DWORD n;
		while(1)
		{
			wsprintf(szfname, "%c:\\",c);
			if(GetDriveType(szfname)!=DRIVE_NO_ROOT_DIR)
			{
				li.iSubItem = 0;
				//strcpy(li.pszText, szfname);
				li.iImage = DRIVE_IMAGE;
				li.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
				li.iItem = iItemNo;
				li.lParam = iItemNo;
				ListView_InsertItem(hListL, &li);

				MySetListItems(hListL, li, LVIF_TEXT,isdirectory,"","","","");
				

				iItemNo++;
			}
			if(c>'z') break;
			c++;
		}
		SetCurrentDirectory(szfnameback);//̈ʒuɖ߂
	}

	//main urlfile
	li.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
        strcpy(li.pszText,mainposition);
        li.iItem = iItemNo;
        li.iSubItem = 0;
        li.lParam = iItemNo;
        li.iImage = FOLDER_YELLOW;
        ListView_InsertItem(hListL, &li);
        
        MySetListItems(hListL, li, LVIF_TEXT,isdirectory,"","","","");


    iItemNo++;	
	addfavoritestolist(hListL,iItemNo);
	iItemNo++;
	addroottolist(hListL,iItemNo);

	localitemnum=iItemNo;
	if(flag==TRUE) 
	{
		savesearch(szBuf);
	}
    return iItemNo;
}

void MySetListItems(HWND hListL,LVITEM &li,UINT mask, char *item1,char *item2,char *item3,char *item4,char *item5)
{
	const int MAX_DAT=3000;
    char txt[MAX_DAT];
	if(li.pszText==NULL) li.pszText = txt;
        li.mask = mask;

        li.iSubItem = 1;
        strcpy(li.pszText, item1);
        ListView_SetItem(hListL, &li);
        li.iSubItem = 2;
        strcpy(li.pszText, item2);
        ListView_SetItem(hListL, &li);
        li.iSubItem = 3;
        strcpy(li.pszText, item3);
        ListView_SetItem(hListL, &li);
        li.iSubItem = 4;
        strcpy(li.pszText, item4);
        ListView_SetItem(hListL, &li);
        li.iSubItem = 5;
        strcpy(li.pszText, item5);
        ListView_SetItem(hListL, &li);
}

void MySetListItems(HWND hListL,LVITEM &li,UINT mask, int itemno, char *item2,char *item3,char *item4,char *item5)
{
	const int MAX_DAT=3000;
    char txt[MAX_DAT];
	wsprintf(txt, "%d", itemno);
	MySetListItems(hListL,li,mask, txt, item2,item3,item4,item5);
}

// directory炵 list \

int SetFolderList(HWND hWnd, HWND hListL, HIMAGELIST hImage,char *file,int mode)
{
    char *urlfile,*p,*timefile;
    int iItemNo = 0;
	long count=0;
    LVITEM li;
	const int MAX_DAT=3000;
    char szBuf[MAX_DAT],buffer[MAX_DAT];
	char url[MAX_DAT],title[MAX_DAT],caption[MAX_DAT];
	li.pszText = url;
	BOOL rootflag=FALSE;
	BOOL flag=FALSE;
	memset(buffer,MAX_DAT,0);
	GetWindowText(hSearchEdit,szBuf,MAX_PATH);
	if(strlen(szBuf)>0) flag=TRUE;

	if(mode==0) 
	{
		urlfile=geturlfile();
	}
	else 
	{
		urlfile=file;
	}
	ifstream in(urlfile);
	if(!in) return 0;
    ListView_DeleteAllItems(hListL);
    while (!in.eof()) {
		url[0]=0;
		title[0]=0;
		caption[0]=0;
		memset(buffer,0,MAX_DAT);
		in.getline(buffer,MAX_DAT);
		if(in.gcount()==0) continue;
		if(flag==TRUE && strstr(buffer,szBuf)==NULL) continue;
		//folder
		if(strstr(buffer,"http://")!=NULL) continue;// url͏
		p=strstr(buffer,"/");
		if(p==NULL) 
		{
			p=strstr(buffer,"\\");
		}
		if(p==NULL) continue;
		p=strchr(buffer,'=');
		if(p==NULL)p=buffer;
		else p++;
		strncpy(url,p,MAX_URL);
		p=strchr(url,',');
		if(p!=NULL) p[0]=0;
		//title
		p=strstr(buffer,"*");
		if(p==NULL) p=buffer;
		strncpy(title,p,MAX_URL);
		p=strchr(title,',');
		if(p!=NULL) p[0]=0;
		//caption
		p=strstr(buffer,",");
		if(p==NULL) p=buffer;
		strncpy(caption,p,MAX_URL);
		p=strchr(caption,',');
		if(p!=NULL) p[0]=0;

        li.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
        li.iItem = iItemNo;
        li.iSubItem = 0;
        li.lParam = iItemNo;
        if (0) {
            li.iImage = FOLDER_YELLOW;
        } else {
            li.iImage = fileimage(url);
        }
        ListView_InsertItem(hListL, &li);
        
		MySetListItems(hListL, li, LVIF_TEXT,iItemNo,buffer,title,caption,"");

        iItemNo++;
    }

	addfavoritestolist(hListL, iItemNo);
	iItemNo++;
	addroottolist(hListL,iItemNo);
	localitemnum=iItemNo;
	if(flag==TRUE) 
	{
		savesearch(szBuf);
	}
    return iItemNo;
}
// [AhX炵 list \

int SetMailAddressList(HWND hWnd, HWND hListL, HIMAGELIST hImage,char *file)
{
    char *urlfile,*p;
    int iItemNo = 0;
	long count=0;
    LVITEM li;
	const int MAX_DAT=3000;
    char szBuf[MAX_PATH],buffer[MAX_DAT];
	char url[3000],title[1000],caption[1000];
	li.pszText = url;
	BOOL rootflag=FALSE;
	BOOL flag=FALSE;
	memset(buffer,MAX_DAT,0);
	GetWindowText(hSearchEdit,szBuf,MAX_PATH);
	if(strlen(szBuf)>0) flag=TRUE;

	urlfile=file;
	ifstream in(urlfile);
	if(!in) return 0;
    ListView_DeleteAllItems(hListL);
    while (!in.eof()) {
		url[0]=0;
		title[0]=0;
		caption[0]=0;
		memset(buffer,0,MAX_DAT);
		in.getline(buffer,MAX_DAT);
		if(in.gcount()==0) break;
		if(flag==TRUE && strstr(buffer,szBuf)==NULL) continue;
		//mail address
		p=strstr(buffer,"@");
		if(p==NULL) continue;
		getmailaddress(buffer,url);
		if(isalpha(url[0])==0) continue;
		//title
		p=strstr(buffer,"*");
		if(p==NULL) p=buffer;
		strncpy(title,p,MAX_URL);
		p=strchr(title,',');
		if(p!=NULL) p[0]=0;
		//caption
		p=strstr(buffer,",");
		if(p==NULL) p=buffer;
		strncpy(caption,p,MAX_URL);
		p=strchr(caption,',');
		if(p!=NULL) p[0]=0;

        li.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
        li.iItem = iItemNo;
        li.iSubItem = 0;
        li.lParam = iItemNo;
        if (0) {
            li.iImage = FOLDER_YELLOW;
        } else {
            li.iImage = FILE_IMAGE;
        }
        ListView_InsertItem(hListL, &li);
        
        MySetListItems(hListL, li, LVIF_TEXT,iItemNo,buffer,title,caption,"");
        iItemNo++;
    }

	addfavoritestolist(hListL, iItemNo);
	iItemNo++;
	addroottolist(hListL,iItemNo);
	localitemnum=iItemNo;
	if(flag==TRUE) 
	{
		savesearch(szBuf);
	}
    return iItemNo;
}

void urldata::setline(char* data)
{
	strcpy(url,data);
	title[0]=0;
	char *p=strchr(url,'\t');
	if(p!=NULL) 
	{
		p[0]=0;
		strcpy(title,p+1);
		p=strchr(title,'\t');
		if(p!=NULL) p[0]=0;
	}
}

void searchtitlestr(char *url,char *title)
{
	const int MAX_DAT=3000;
	urldata ud;
    char buffer[MAX_DAT];
	char *urlfile=geturlfile();
	ifstream in(urlfile);
	while(1)
	{
		memset(buffer,0,MAX_DAT);
		in.getline(buffer,MAX_DAT-2);
		if(in.gcount()==0) break;
		ud.setline(buffer);
		if(strcmp(ud.geturl(),url)==0)
		{
			strcpy(title,ud.gettitle());
			break;
		}
	}
//	wsprintf(title,"tes");
}
// memo \

int SetMemoList(HWND hWnd, HWND hListL, HIMAGELIST hImage,char *file,int mode)
{
    char *urlfile,*p,*timefile;
    int iItemNo = 0;//f[^̓XLbv
	int allnum=0;//ʂԍAŔ\̃f[^
	int urllen,titlelen,captionlen;
    LVITEM li;
	const int MAX_DAT=3000;
    char szBuf[MAX_PATH],buffer[MAX_DAT];
	char url[MAX_DAT],title[MAX_DAT],caption[MAX_DAT],timed[16];
	BOOL rootflag=FALSE;
	BOOL flag=FALSE;
	memset(buffer,MAX_DAT,0);
	GetWindowText(hSearchEdit,szBuf,MAX_PATH);
	if(strlen(szBuf)>0) flag=TRUE;

	urlfile=file;
	ifstream in(urlfile);
	ifstream ti;
	if(!in) return 0;
	if(mode==0) ti.open(timefile);
    ListView_DeleteAllItems(hListL);
    while (!in.eof()) {
		url[0]=0;
		title[0]=0;
		caption[0]=0;
		memset(buffer,0,MAX_DAT);
		in.getline(buffer,MAX_DAT-2);
		if(in.gcount()==0 ) continue;
		//
		p=buffer;
		if(p==NULL) continue;
		strncpy(url,p,MAX_URL);
		p=strchr(url,'\t');
		if(p!=NULL) p[0]=0;
		//title
		p=buffer+strlen(url);
		if(strchr(p,'\t')!=NULL) p=strchr(p,'\t')+1;
		strncpy(title,p,MAX_URL);
		p=strchr(title,'\t');
		if(p!=NULL) p[0]=0;
		titlelen=strlen(title);
		//caption
		p=buffer+strlen(url)+titlelen;
		if(strchr(p,'\t')!=NULL) p=strchr(p,'\t')+1;
		strncpy(caption,p,MAX_URL);
		p=strchr(caption,'\t');
		if(p!=NULL) p[0]=0;
		

        li.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
        li.pszText = url;
        li.iItem = iItemNo;
        li.iSubItem = 0;
        li.lParam = iItemNo;
        if (0) {
            li.iImage = FOLDER_YELLOW;
        } else {
            li.iImage = FILE_IMAGE;
        }
        ListView_InsertItem(hListL, &li);
		if(mode!=0) strcpy(timed,"");
        MySetListItems(hListL, li, LVIF_TEXT,allnum,timed,title,caption,buffer);

        iItemNo++;
		allnum++;
		if (in.eof())break;
    }
	//@favorite \
	addfavoritestolist(hListL, iItemNo);
	iItemNo++;
	addroottolist(hListL,iItemNo);

	localitemnum=iItemNo;
	if(flag==TRUE) 
	{
		savesearch(szBuf);
	}
    return iItemNo;
}

int SetRootList(HWND hList, HIMAGELIST hImage)
{
    int iItemNo = 0;
	ListView_DeleteAllItems(hList);
	
	addSptolist(hListL, BMfiletitle,iItemNo);
	iItemNo++;
	addfavoritestolist(hListL, iItemNo);
	iItemNo++;
	addsearchtolist(hListL, iItemNo);
	iItemNo++;
	addSptolist(hListL, favfiletitle,iItemNo);
	iItemNo++;
	addSptolist(hListL, urlhistitle,iItemNo);
	iItemNo++;
	addSptolist(hListL, folderhistitle,iItemNo);
	iItemNo++;
	addroottolist(hListL,iItemNo);

	return iItemNo;
}

// initlist class data\

int SetInitClassList(HWND hListL, HIMAGELIST hImage,initlist &IDATA)
{
    //char *urlfile,*p,*timefile;
    int iItemNo = 0;//f[^̓XLbv
	int allnum=0;//ʂԍAŔ\̃f[^
	int urllen,titlelen,captionlen;
    LVITEM li;
	const int MAX_DAT=3000;
    char SearchW[MAX_PATH],buffer[MAX_DAT];
	char text[MAX_DAT],path[MAX_DAT],caption[MAX_DAT],timed[16];
	BOOL rootflag=FALSE;
	BOOL flag=FALSE;
	_BY_HANDLE_FILE_INFORMATION finfo;

	memset(buffer,MAX_DAT,0);
	GetWindowText(hSearchEdit,SearchW,MAX_PATH);
	if(strlen(SearchW)>0) flag=TRUE;
	
	ListView_DeleteAllItems(hListL);
	int max =IDATA.getcount();
	
	for(int num=1; num<=max; num++)
	{
		allnum++;
		strcpy(caption, IDATA.getname(num));
		strcpy(path, IDATA.getpath(num));
		if(flag==TRUE ) 
			if(strstr(caption,SearchW)==NULL && strstr(path,SearchW)==NULL) continue;
        li.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
        li.pszText = path;
        li.iItem = iItemNo;
        li.iSubItem = 0;
        li.lParam = iItemNo;
        if (0) {
            li.iImage = FOLDER_YELLOW;
        } else {
            li.iImage = FILE_IMAGE;
        }
        ListView_InsertItem(hListL, &li);
		strcpy(timed,"");
		/* x̂
		if(exist(path) ) 
		{
			HANDLE f;
			f=CreateFile(path,GENERIC_READ,FILE_SHARE_READ,NULL,
				OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
			if(f!=NULL) 
			{
				GetFileInformationByHandle(f,&finfo);
				FileTimeToMyListTime(finfo.ftLastWriteTime, timed);
				//size=max(GetFileSize(f,NULL),0);
				CloseHandle(f);
			}
		}
		*/
        MySetListItems(hListL, li, LVIF_TEXT,allnum,timed,caption,"",buffer);

        iItemNo++;
    }
	//@favorite \
	addfavoritestolist(hListL, iItemNo);
	iItemNo++;
	addroottolist(hListL,iItemNo);

	localitemnum=iItemNo;
	if(flag==TRUE) 
	{
		savesearch(SearchW);
	}
    return iItemNo;
}


int SetSearchList(HWND hWnd, HWND hListL, HIMAGELIST hImage,char *file,int mode)
{
	return SetMemoList(hWnd, hListL, hImage, getsearchfile(), mode);
}

// url list \

int SetUrlList(HWND hWnd, HWND hListL, HIMAGELIST hImage,char *file,int mode)
{
    char *urlfile,*p,*timefile;
    int iItemNo = 0;//f[^̓XLbv
	int allnum=0;//ʂԍAŔ\̃f[^
	int urllen,titlelen,captionlen;
    LVITEM li;
	const int MAX_DAT=3000;
    char szBuf[MAX_PATH],buffer[MAX_DAT];
	char url[MAX_DAT],title[MAX_DAT],caption[MAX_DAT],timed[16];
	BOOL rootflag=FALSE;
	BOOL flag=FALSE;
	BOOL urlfolderflag;
	memset(buffer,MAX_DAT,0);
	GetWindowText(hSearchEdit,szBuf,MAX_PATH);
	if(strlen(szBuf)>0) 
	{
		savesearch(szBuf);
		flag=TRUE;
	}

	if(mode==MAIN_MODE) 
	{
		urlfile=geturlfile();
		timefile=gettimefile();
	}
	else urlfile=file;
	GetCurrentDirectory(MAX_PATH,currentdir);
	wsprintf(currentfile,urlfile);
	BOOL liteflag=checklitebrowser(urlfile);
	ifstream in(urlfile);
	if(!in) return 0;
	ifstream ti;
	if(mode==MAIN_MODE) ti.open(timefile);
    ListView_DeleteAllItems(hListL);
    while (!in.eof()) {
		memset(url,0,MAX_DAT);
		memset(title,0,MAX_DAT);
		memset(caption,0,MAX_DAT);
		urlfolderflag=FALSE;
		memset(buffer,0,MAX_DAT);
		in.getline(buffer,MAX_DAT-2);
		if(in.gcount()==0) continue;
		//url ^uA󔒁A"A>Ő؂
		p=strstr(buffer,"http://");
		if(p==NULL) 
		{
			p=strstr(buffer,"folder:");
			if(p!=NULL) 
			{
				urlfolderflag=TRUE;
				p+=7;
			}
		}
		if(p==NULL) continue;
		strncpy(url,p,MAX_URL);
		p=strchr(url,'\"');
		if(p!=NULL) p[0]=0;
		p=strchr(url,'\'');
		if(p!=NULL) p[0]=0;
		p=strchr(url,'>');
		if(p!=NULL) p[0]=0;
		p=strchr(url,' ');
		if(p!=NULL) p[0]=0;
		p=strchr(url,'\t');
		if(p!=NULL) p[0]=0;
		if(liteflag)
		{
			p=strchr(url,'*');
			if(p!=NULL) p[0]=0;
		}
		//title
		if(!urlfolderflag) p=strstr(buffer,"http://")+strlen(url);
		else p=buffer;
		if(liteflag)
		{
			p=strstr(buffer,"*");
			if(p==NULL) p=buffer;
		}
		if(strchr(p,'\t')!=NULL) p=strchr(p,'\t')+1;
		strncpy(title,p,MAX_URL);
		p=strchr(title,'\t');
		if(p!=NULL) p[0]=0;
		titlelen=strlen(title);
		if(mode!=MAIN_MODE) searchtitlestr(url,title);//if(titlelen==0) 
		//caption
		if(!urlfolderflag) p=strstr(buffer,"http://")+strlen(url)+titlelen;
		else p=buffer;
		if(strchr(p,'\t')!=NULL) p=strchr(p,'\t')+1;
		strncpy(caption,p,MAX_URL);
		p=strchr(caption,'\t');
		if(p!=NULL) p[0]=0;
		
		// f[^iԂ̐擪łȂj@͔\
		if(mode==MAIN_MODE)
		{
			ti.read(timed,14);
			timed[12]=0;
			if(isdigit(timed[0])==0) 
			{
				allnum++;
				continue;
			}
		}
		// filter
		if(flag==TRUE ) 
		if(strlen(buffer)>0) 
		if(strstr(buffer,szBuf)==NULL) 
		{
			allnum++;
			continue;
		}

        li.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
        li.pszText = url;
        li.iItem = iItemNo;
        li.iSubItem = 0;
        li.lParam = iItemNo;
        if (urlfolderflag) {
            li.iImage = FOLDER_YELLOW;
        } else {
            li.iImage = URL_IMAGE;
        }
        ListView_InsertItem(hListL, &li);
		if(mode!=0) strcpy(timed,"");
        if(!urlfolderflag) 
			MySetListItems(hListL, li, LVIF_TEXT,allnum,timed,title,caption,buffer);
		else MySetListItems(hListL, li, LVIF_TEXT,isdirectory,timed,title,caption,buffer);
        
        iItemNo++;
		allnum++;
    }
	//@favorite \
	addfavoritestolist(hListL,iItemNo);
	iItemNo++;
	addsearchtolist(hListL,iItemNo);
	iItemNo++;
	addroottolist(hListL,iItemNo);


	localitemnum=iItemNo;
	if(flag==TRUE) 
	{
		savesearch(szBuf);
	}
    return iItemNo;
}

void ChangeLocalDrive(HWND hWnd, HWND hListL, HWND hDirEdit, HIMAGELIST hImage)
{
    HINSTANCE hInst;
    HWNDSET hwndset;

    hwndset.hwnd1 = hListL;
    hwndset.hwnd2 = hDirEdit;
    hwndset.hImage = hImage;

    hInst = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);
    DialogBoxParam(hInst, "MYDRIVE", hWnd, (DLGPROC)MyDriveProc, (LPARAM)&hwndset);
    return;
}


LRESULT CALLBACK MyDriveProc(HWND hDlg, UINT msg, WPARAM wp, LPARAM lp)
{
    static HWND hList;
    static HWND hListL, hDirEdit, hParent;
    char szDrv[4];
    HWNDSET *lphset;
    static HIMAGELIST hImage;

    switch (msg) {
        case WM_INITDIALOG:
            lphset = (HWNDSET *)lp;
            hListL = lphset->hwnd1;
            hDirEdit = lphset->hwnd2;
            hImage = lphset->hImage;
            hParent = GetParent(hDlg);
            hList = GetDlgItem(hDlg, IDC_LIST1);
            DlgDirList(hDlg, "*.*", IDC_LIST1, 0, DDL_DRIVES);
            return TRUE;
        case WM_COMMAND:
            switch (LOWORD(wp)) {
                case IDOK:
                    DlgDirSelectEx(hDlg, szDrv, sizeof(szDrv), IDC_LIST1);
                    strcat(szDrv, "\\");
                    SetCurrentDirectory(szDrv);
                    SetMyLocalDir(hParent, hListL, hDirEdit, hImage);
                    EndDialog(hDlg, IDOK);
                    return TRUE;
                case IDCANCEL:
                    EndDialog(hDlg, IDCANCEL);
                    return TRUE;
            }
            return FALSE;
    }
    return FALSE;
}


// IDOK= ǉAIDCANCEL=@~

int MyAddUrl(HWND hWnd)
{
    char szDir[MAX_PATH];
    HINSTANCE hInst;
    int iIndex;

    hInst = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);
    iIndex = DialogBoxParam(hInst, "addurl", hWnd,
        (DLGPROC)AddUrlProc, (LPARAM)szDir);
    return iIndex;
}

void MyCreatDir(HWND hWnd, HWND hList, HWND hStatic)
{
    char szDir[MAX_PATH];
	char command[MAX_PATH*2];
    HINSTANCE hInst;
    int iIndex;

    hInst = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);
    iIndex = DialogBoxParam(hInst, "MYCREATEDIR", hWnd,
        (DLGPROC)MyCreateDirProc, (LPARAM)szDir);
    if (iIndex == IDCANCEL)
        return;
	wsprintf(command,"mkdir %s",szDir);
	system(command);
    //CreateDirectory(szDir);
    //GetAllFiles(hWnd, hList, hStatic, &inet);
    return;
}




void MyCreatFile(HWND hWnd, HWND hList, HWND hStatic)
{
    char szDir[MAX_PATH];
//	char command[MAX_PATH*2];
    HINSTANCE hInst;
    int iIndex;

    hInst = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);
    iIndex = DialogBoxParam(hInst, "MYCREATEDIR", hWnd,
        (DLGPROC)MyCreateDirProc, (LPARAM)szDir);
    if (iIndex == IDCANCEL)
        return;
	ofstream ou;
	if(strlen(szDir)>0) ou.open(szDir);
    return;
}

//JgfBNgɎԖeLXgt@C쐬A㏑`FbNȂ

void MyCreatBlankFile()
{
    char szDir[MAX_PATH];/*
	char command[MAX_PATH*2];
    HINSTANCE hInst;
    int iIndex;

    hInst = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);
    iIndex = DialogBoxParam(hInst, "MYCREATEDIR", hWnd,
        (DLGPROC)MyCreateDirProc, (LPARAM)szDir);
    if (iIndex == IDCANCEL)
        return;*/

	SYSTEMTIME st;
	char form[]="%04d%02d%02d-%02d%02d%02d.txt";

	GetLocalTime(&st);
	wsprintf(
		szDir,
		form,
	
		st.wYear,
		st.wMonth,
		st.wDay,

		st.wHour,
		st.wMinute,
		st.wSecond
	);
	ofstream ou;
	if(strlen(szDir)>0) ou.open(szDir);
    return;
}



LRESULT CALLBACK MyCreateDirProc(HWND hDlg, UINT msg, WPARAM wp, LPARAM lp)
{
    static char *lpDirName;
    static HWND hEdit;

    switch (msg) {
        case WM_INITDIALOG:
            lpDirName = (char *)lp;
            hEdit = GetDlgItem(hDlg, IDC_EDIT1);
            return TRUE;
        case WM_COMMAND:
            switch (LOWORD(wp)) {
                case IDOK:
                    Edit_GetText(hEdit, lpDirName, MAX_PATH);
                    EndDialog(hDlg, IDOK);
                    return TRUE;
                case IDCANCEL:
                    EndDialog(hDlg, IDCANCEL);
                    return TRUE;
            }
            return FALSE;
    }
    return FALSE;
}



LRESULT CALLBACK AddUrlProc(HWND hDlg, UINT msg, WPARAM wp, LPARAM lp)
{
    static char url[MAX_URL],title[1000],caption[1000];
    static HWND hUrl,hTitle,hCaption;

    switch (msg) {
        case WM_INITDIALOG:
            hUrl = GetDlgItem(hDlg, IDC_URL);
            hTitle = GetDlgItem(hDlg, IDC_URL_TITLE);
            hCaption = GetDlgItem(hDlg, IDC_URL_CAPTION);
			
            return TRUE;
        case WM_COMMAND:
            switch (LOWORD(wp)) {
                case ID_COPY_URL:
					Edit_SetText(hUrl, szDir);
					Edit_SetText(hTitle, Buf[3]);
					return TRUE;
                case IDOK:
                    Edit_GetText(hUrl, url, MAX_PATH);
                    Edit_GetText(hTitle, title, 1000);
                    Edit_GetText(hCaption, caption, 1000);
					addurl(url,title,caption,"\t");
                    EndDialog(hDlg, IDOK);
                    return TRUE;
                case IDCANCEL:
                    EndDialog(hDlg, IDCANCEL);
                    return TRUE;
            }
            return FALSE;
    }
    return FALSE;
}



HWND MakeMyList(HWND hWnd)
{
    HWND hList;
    DWORD dwStyle;
    HINSTANCE hInst;

    hInst = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);
    hList = CreateWindowEx(0, WC_LISTVIEW, "",
        WS_CHILD | WS_VISIBLE | LVS_REPORT | WS_BORDER | LVS_SINGLESEL ,//
        0, 0, 0, 0, hWnd, (HMENU)100, hInst, NULL);
    dwStyle = ListView_GetExtendedListViewStyle(hList);
    dwStyle |= LVS_EX_FULLROWSELECT |
         LVS_EX_HEADERDRAGDROP;//LVS_EX_GRIDLINES |
    ListView_SetExtendedListViewStyle(hList, dwStyle);
    return hList;
}
