// bmedit.h

#include "stdio.h"

#define ID_LIST 100
#define ID_STATIC 101
#define ID_LISTL 102
#define ID_STATICL 103
#define ID_STATUSBAR 104
#define ID_BUTTON 105
#define ID_SEARCH 106
#define ID_DIRL 107
#define ID_EDIT 108
#define ID_UP 109
#define ID_DOWN 110

#define CONTEXT_GETFILE 100
#define CONTEXT_CONNECT 200
#define CONTEXT_PUTFILE 300
#define MAX_INFO MAX_PATH

#define ASCII 1
#define BINARY 0

#define MAX_URL MAX_PATH



typedef struct _tagAccount{
    char szUserName[MAX_INFO];
    char szPassWord[MAX_INFO];
    char memo[MAX_INFO];
} ACCOUNT;

typedef struct _tagFTPAddress{
	char name[MAX_INFO];
    char szHost[MAX_INFO];
    char szBaseDir[MAX_PATH];
    char szLocalDir[MAX_PATH];
	void setname(char *n){strcpy(name,n);};
	void setnamefrommenu(char *n){char buf[6];sscanf(n,"%s %s",buf,name);};
} FTPADDRESS;
/*
typedef struct _tagINETHANDLE{
    HINTERNET hInternet;
    HINTERNET hHost;
} INETHANDLE;
*/

typedef struct _tagFNAME{
    char szFName[MAX_PATH];
    char szLocalFileName[MAX_PATH];
} FNAME;

typedef struct _tagHWNDSET{
    HWND hwnd1;
    HWND hwnd2;
    HIMAGELIST hImage;

} HWNDSET;


typedef struct _tagSTATUSCALLBACK
{
    HWND hwndStatus;
    DWORD dwFrom;
} STATUSCALLBACK;
    

class urldata
{
private:
	char url[3000];
	char title[3000];
public:
	void setline(char*data);
	char* geturl(){return url;};
	char* gettitle(){return title;};
};


_extern HINSTANCE hInst;

_extern int itemmode;
#define FAVFILE_MODE 7
#define BROWSER_MODE 6
#define SEARCH_MODE 5
#define MEMO_MODE 4
#define FOLDER_MODE 3
#define MAIL_MODE 2
#define URL_MODE 1
#define EXPLORER_MODE 0

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK AddUrlProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK MyFtpAddressProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK MyGetFNameProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK MyDriveProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK MyCreateDirProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK MyTextProc(HWND, UINT, WPARAM, LPARAM);
int CALLBACK MyCompProc(LPARAM, LPARAM, LPARAM);
ATOM InitApp(HINSTANCE);
BOOL InitInstance(HINSTANCE, int);
void SetHost(HWND, FTPADDRESS *);
int SetMyLocalDir(HWND, HWND, HWND, HIMAGELIST);
void ChangeLocalDrive(HWND, HWND, HWND, HIMAGELIST);
HWND MakeMyList(HWND);

//ǉ
void settitle(HWND &hWnd,BOOL);
void resettitle(HWND &hWnd);
void settransfermode();
BOOL MyAddUrl(HWND);
void MyCreatDir(HWND, HWND, HWND);
void MyCreatFile(HWND, HWND, HWND);
void MyCreatBlankFile();
void localrename(HWND, HWND ,HWND ,FNAME *);
void MyDelFile(HWND);
void MyRemoveDir(HWND);
void settransfermode(int);

void addlistitem(char *name,int num);
int SetFolderList(HWND hWnd, HWND hListL, HIMAGELIST hImage,char*,int);
int SetUrlList(HWND hWnd, HWND hListL, HIMAGELIST hImage,char*,int);
int SetMemoList(HWND hWnd, HWND hListL, HIMAGELIST hImage,char*,int);
int SetSearchList(HWND hWnd, HWND hListL, HIMAGELIST hImage,char*,int);
int SetMailAddressList(HWND hWnd, HWND hListL, HIMAGELIST hImage,char*);

